<?php defined('_JEXEC') or die('Restricted Access');
/*------------------------------------------------------------------------
# JOOFORGE.com - Il Web All'Italiana
# ------------------------------------------------------------------------
# Copyright  2004-2009 JOOFORGE.com. Tutti i diritti riservati.
# Website:  http://www.jooforge.com/
-------------------------------------------------------------------------*/

// Include library dependencies
jimport('joomla.filter.input');
/**
* Jukebox Item Table class
* @package Jukebox
*/
class TableItem extends JTable
{
  /**
   * Primary Key
   *
   * @var int
   */
  var $id = null;
  /**
   * @var int
   */
  var $catid = null;
  /**
   * @var string
   */
  var $title = null;
  
  /**
   * @var string
   */
  var $alias = null;
  /**
   * @var string
   */
  var $cover = null;
  /**
   * @var string
   */
  var $mp3 = null;
  /**
   * @var string
   */
  var $artist = null;
  /**
   * @var string
   */
  var $description = null;
  /**
   * @var int
   */
  var $published = null;
  /**
   * @var int
   */
  var $ordering = null;
  
  /**
   * Constructor
   *
   * @param object Database connector object
   */
  function __construct(&$db)
  {
	  parent::__construct('#__jukebox', 'id', $db);
  }
  /**
   * Overloaded bind function
   *
   * @acces public
   * @param array $hash named array
   * @return null|string null is operation was satisfactory, otherwise returns an error
   * @see JTable:bind
   */
  function bind($array, $ignore = '')
  {
	  if (key_exists('params', $array) && is_array($array['params'])) {
		  $registry = new JRegistry();
		  $registry->loadArray($array['params']);
		  $array['params'] = $registry->toString();
	  }
	  return parent::bind($array, $ignore);
  }
  /**
   * Overloaded check method to ensure data integrity
   *
   * @access public
   * @return boolean True on success
   */
  function check()
  {
	  /** check for valid name */
	  if (trim($this->title) == '') {
		  $this->_error = JText::_('Please provide a valid title');
		  return false;
	  }
	  /** check for existing name */
	  $query = 'SELECT id FROM #__jukebox WHERE title = ' . $this->_db->Quote($this->title) . ' AND catid = ' . (int)$this->catid;
	  $this->_db->setQuery($query);
	  $xid = intval($this->_db->loadResult());
	  if ($xid && $xid != intval($this->id)) {
		  $this->_error = JText::sprintf('WARNNAMETRYAGAIN', JText::_('Item'));
		  return false;
	  }
	  if (empty($this->alias)) {
		  $this->alias = $this->title;
	  }
	  $this->alias = JFilterOutput::stringURLSafe($this->alias);
	  if (trim(str_replace('-', '', $this->alias)) == '') {
		  $datenow =& JFactory::getdate();
		  $this->alias = $datenow->toFormat("%Y-%m-%d-%H-%M-%S");
	  }
	  jimport('joomla.filter.output');
	  return true;
  }
}
